SystemOrganization addCategory: #'Tp1-TADP'!
SystemOrganization addCategory: #'Tp1-TADP-Test'!

Trait named: #NoPoceado
	uses: {}
	category: 'Tp1-TADP'!

Trait named: #Poceado
	uses: {}
	category: 'Tp1-TADP'!

TestCase subclass: #Testeador
	instanceVariableNames: 'bruno quini6 apostaConMarta apuesta loto quini pagaLaPutaMadre prodeGanaRiver agenciaPirulo jugada sorteo bruna altaJugada nano unaJugada otraJugada teddy laAgenciaDeChola pancho quiniela losHijosDePuta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP-Test'!

!Testeador methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:50'!
testApuestaInicialLoto

	agenciaPirulo := Agencia new.
	loto := Loto new.
	bruno := Timbero new.
	jugada := OrderedCollection new.
	sorteo := Sorteo new.
	
	bruno initialize.
	loto initialize.
	agenciaPirulo initialize.
	
	jugada addAll: #(4 8 15 16 23 42).
	
	bruno armarApuestaDe: loto con: jugada para: agenciaPirulo con: 2.
	bruno jugar.
	
	sorteo sorteame: jugada alJuego: loto.
	self assert: agenciaPirulo caja equals: 0.28! !

!Testeador methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/7/2012 15:22'!
testApuestaInicialPagaOPaga

teddy := Timbero new.
laAgenciaDeChola := Agencia new.
pagaLaPutaMadre := PagaOPaga new.
sorteo := Sorteo new.

teddy initialize.
laAgenciaDeChola initialize.
pagaLaPutaMadre initialize.
sorteo initialize.

teddy armarApuestaDe: pagaLaPutaMadre con: #(1 24 21 73 84 52 16 7 27 72 54 12 94 90 43) para: laAgenciaDeChola con: 15.

"Aca no le pega a ningun numero"
sorteo sorteame: #(0 2 3 4 5 6 8 9 10 11 13 14 15 17 18) alJuego: pagaLaPutaMadre.
self assert: laAgenciaDeChola caja equals: 0.

"Aca le pega a todos"
sorteo sorteame: #(1 24 21 73 84 52 16 7 27 72 54 12 94 90 43) alJuego: pagaLaPutaMadre.
self assert: laAgenciaDeChola caja equals: (405/8)*(10/100).
! !

!Testeador methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/7/2012 17:41'!
testApuestaInicialQuiniela

pancho := Timbero new.
losHijosDePuta := Agencia new.
quiniela := Quiniela new.
sorteo := Sorteo new.

pancho initialize.
losHijosDePuta initialize.
quiniela initialize.
sorteo initialize.

pancho armarApuestaDe: quiniela con: #(55 10) para: losHijosDePuta con: 100.

"Aca no le pega a ningun numero"
sorteo sorteame: #(0 2 3 10 43 12 84 999 102 383 545 146 728 82 75 25 82 94 66 3333) alJuego: quiniela.
self assert: losHijosDePuta caja equals: 17.
self assert: pancho ganancia equals: 0.

"Aca le pega a todos"
sorteo sorteame: #(1 2 3 4 5 6 7 8 9 55 11 12 13 14 15 16 17 18 19 20) alJuego: quiniela.
self assert: losHijosDePuta caja equals: 17.
! !

Object subclass: #Agencia
	instanceVariableNames: 'caja aPagar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:57'!
aPagar
	^ aPagar! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:04'!
aPagar: anObject
	aPagar add: anObject.! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:01'!
caja
	^ caja! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:01'!
caja: anObject
	caja := anObject! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:02'!
ganaste: plata 
	self caja: caja + plata.! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:03'!
initialize 
	self caja: 0.
	aPagar := OrderedCollection new..! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:09'!
pagale: pago
	self aPagar: pago.! !

Object subclass: #Apuesta
	instanceVariableNames: 'juego jugada agencia monto jugador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
agencia
	^ agencia! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
agencia: anObject
	agencia := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:18'!
cuantosAciertosTieneEn: jugadaGanadora
	^ self jugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaEn: jugadaGanadora sumaUno: unNumero) ]! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego
	^ juego! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego: anObject
	juego := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
jugada
	^ jugada! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
jugada: anObject
	jugada := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador
	^ jugador! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador: anObject
	jugador := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
monto
	^ monto! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
monto: anObject
	monto := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:19'!
siEstaEn: unaJugada sumaUno: unNumero
	(unaJugada includes: unNumero)
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ 0 ]! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:45'!
sosGanadora: jugadaGanadora 
	^self jugada allSatisfy:[:unNumero | jugada includes: unNumero].! !

Object subclass: #Juego
	instanceVariableNames: 'apuestasEnJuego'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
apuestasEnJuego
	^ apuestasEnJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:10'!
initialize 			
	apuestasEnJuego := OrderedCollection new.
		
		! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
recibiApuesta: apuesta
	self apuestasEnJuego add: apuesta! !

Juego subclass: #Loto
	uses: Poceado
	instanceVariableNames: 'pozo'
	classVariableNames: 'PorcentajeFijoPorJugada PorcentajeParaAgencia'
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Loto class
	uses: Poceado classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 21:21'!
PorcentajeFijoPorJugada
	^ 0.12! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 21:12'!
PorcentajeParaAgencia
	^ 0.05! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 20:31'!
actualizarPozo
	self pozo: apuestasEnJuego size * 2! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:13'!
calculaAciertos: numeroDeAciertos paraJugada: jugadaGanadora
	^ self apuestasEnJuego select: [ :unaAp | (unaAp cuantosAciertosTieneEn: jugadaGanadora) = numeroDeAciertos ]! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:05'!
calculaGanadoresYRepartiPremio: jugadaGanadora 
     | seisAsiertos cincoAsiertos cuatroAsiertos  |

	self actualizarPozo.	
	self repartirAAgencias.
	
	seisAsiertos := self calculaAciertos: 6 paraJugada: jugadaGanadora.	
	cincoAsiertos := self calculaAciertos: 5 paraJugada: jugadaGanadora.	
	cuatroAsiertos := self calculaAciertos: 4 paraJugada: jugadaGanadora.
	
	self pagarA: seisAsiertos conAciertos: 6.
	self pagarA: cincoAsiertos conAciertos: 5.
	self pagarA: cuatroAsiertos conAciertos: 4.



! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 21:23'!
initialize 
	   super initialize.
	! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:43'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta jugador 
				ganaste: 
					(self pozo * (apuesta juego porcentajePara: numeroDeAciertos) / apuestasGanadoras size) ].
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste:
					(self pozo * (apuesta juego porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgencia ]! !

!Loto methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:34'!
porcentajePara: unNumero
	unNumero == 6 ifTrue: [^0.4].
	unNumero == 5 ifTrue: [^0.17].
	unNumero == 4 ifTrue: [^0.05].! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:01'!
pozo
	^ pozo! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:01'!
pozo: anObject
	pozo := anObject! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:03'!
repartirAAgencias
	apuestasEnJuego do: [ :apuest | apuest agencia ganaste: (apuest monto * self PorcentajeFijoPorJugada) ]! !

Juego subclass: #PagaOPaga
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

PagaOPaga class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

Juego subclass: #Prode
	uses: Poceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Prode class
	uses: Poceado classTrait
	instanceVariableNames: ''!

Juego subclass: #Quiniela
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Quiniela class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

!Quiniela methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 20:23'!
calculaGanadoresYRepartiPremio: jugadaGanadora 
	
	"Las agencias ganan el 17% de las jugadas realiadas en ellas"
	apuestasEnJuego do:[:ap | ap agencia ganaste: (ap monto*17/100)].  
! !

Object subclass: #Sorteo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Sorteo methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 12:05'!
initialize 
	apuestasLoto := OrderedCollection new.
	apuestasQuiniela  := OrderedCollection new.
	apuestasPoP  := OrderedCollection new.
	apuestasProde  := OrderedCollection new.
					! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:12'!
sorteame: jugadaGanadora alJuego: juego
	juego calculaGanadoresYRepartiPremio: jugadaGanadora! !

Object subclass: #Timbero
	instanceVariableNames: 'apuestas ganancia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:01'!
apuestas
	^ apuestas! !

!Timbero methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
armarApuestaDe: unJuego con: unaJugada para: unaAgencia con: unMonto
	| unaApuesta |
	
	unaApuesta := Apuesta new.
	unaApuesta juego: unJuego.
	unaApuesta jugada: unaJugada.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unMonto.
	unaApuesta jugador: self.
	
	self apuestas add: unaApuesta.
	
	! !

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 17:41'!
ganancia 
	^ ganancia ! !

!Timbero methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:49'!
ganancia: unNumero
	ganancia := unNumero! !

!Timbero methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:32'!
ganaste: unaCantidad
	self ganancia: (self ganancia + unaCantidad)  ! !

!Timbero methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:47'!
initialize 
	super initialize. 
	apuestas := OrderedCollection new.
	self ganancia: 0.


	! !

!Timbero methodsFor: 'accessing' stamp: 'GuidoWagner 9/6/2012 17:44'!
jugar
	self apuestas do:[ :apuesta | apuesta juego recibiApuesta: apuesta ].! !
